<?php
// inc_cronjob.php
// Überprüfen auf fällige Aufgaben

function wpps_doTasks() {
    fullUpdate();
}

function fullUpdate() {
    global $wpps;

    if (!isset($wpps) || !isset($wpps->settings)) {
        return;
    }

    $lastupdate = $wpps->settings['lastupdate'] ?? 0;
    $interval = $wpps->settings['interval'] ?? 0;
    $updatetype = $wpps->settings['updatetype'] ?? '';

    if (
        current_time('timestamp', 0) > ($lastupdate + (3600 * $interval)) &&
        $updatetype === 'auto'
    ) {
        $wpps->setSilent();
        $wpps->updateAll(1);
    }
}

function usageUpdate_onSave($post_id) {
    global $wpps;

    if (!isset($wpps)) {
        return;
    }

    $typestocheck = ['page'];
    $post = get_post($post_id);

    if ($post && in_array($post->post_type, $typestocheck, true)) {
        $wpps->checkUsage($post_id);
    }
}

function usageUpdate_all() {
    global $wpps;

    if (!isset($wpps)) {
        return;
    }

    $count_posts = wp_count_posts('page');
    $published_count = $count_posts->publish ?? 0;

    $shortcodes = get_posts([
        'posts_per_page' => 99,
        'post_type'      => 'wpps-shortcodes',
    ]);

    foreach ($shortcodes as $code) {
        update_post_meta($code->ID, 'wpps-status', '0');
    }

    $posts = get_posts([
        'posts_per_page' => $published_count,
        'post_type'      => 'page',
    ]);

    foreach ($posts as $post) {
        usageUpdate_onSave($post->ID);
    }

    wp_reset_postdata();
}

add_action('init', 'wpps_doTasks');
add_action('save_post', 'usageUpdate_onSave');
add_action('wp_trash_post', 'usageUpdate_all');
add_action('wp_untrash_post', 'usageUpdate_all');
?>
